SystemOrganization addCategory: #'Test-ComposicionToTrait'!

TestCase subclass: #ComposicionToTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-ComposicionToTrait'!

!ComposicionToTrait methodsFor: 'as yet unclassified' stamp: 'Pablo 5/10/2013 22:59'!
claseBuilderA
	
	|claseA|
	claseA := Object subclass: #A
	instanceVariableNames: 'ClaseB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-ComposicionToTrait'.
	
	claseA compile: 'setClase: unaClase   ClaseB := unaClase.'.
	claseA compile: 'getClase  ^ClaseB.'.
	
	^claseA.! !

!ComposicionToTrait methodsFor: 'as yet unclassified' stamp: 'Pablo 5/10/2013 22:39'!
claseBuilderB
	
	|claseB|
	claseB := Object subclass: #B
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-ComposicionToTrait'.
	
	claseB compile: 'saludar ^9999'.
	
	^claseB.! !

!ComposicionToTrait methodsFor: 'as yet unclassified' stamp: 'Pablo 5/10/2013 22:48'!
claseBuilderC: clasePadre
	
	|claseC|
	claseC := clasePadre subclass: #C
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-ComposicionToTrait'.
	
	claseC compile: 'comentar  ^11111'.
	
	^claseC.! !

!ComposicionToTrait methodsFor: 'as yet unclassified' stamp: 'Pablo 5/10/2013 23:09'!
testPrueba
	
	|unA 		unB  unC	extractedB 	listaJerarquias 		listaTraits		comentarConComposicion comentarConTrait saludarConComposicion saludarConTrait unaClaseA unaClaseB unaClaseC| 
	
	unaClaseA := self claseBuilderA.
	unaClaseB := self claseBuilderB.
	unaClaseC := self claseBuilderC: unaClaseB.
	
	unA :=  unaClaseA new.
	unB := unaClaseB  new.
	unC := unaClaseC new.
	
	unA setClase: unB.
	listaTraits := Set new.
	comentarConComposicion := unC comentar.
	saludarConComposicion := unA getClase saludar.
			
	extractedB := unA instVarNamed: 'ClaseB'. 
	unA class removeInstVarNamed: 'ClaseB'.
	
	listaJerarquias := extractedB class allSubclasses.
	listaJerarquias add: extractedB class.
	
	listaJerarquias do: [:subClase | listaTraits add: (self traitConverter: subClase)].  
	
	listaTraits do: [:trait | unA class addToComposition: trait ].
			
	saludarConTrait := unA saludar.
	comentarConTrait := unA comentar. 	
	
	
	^self assert: comentarConComposicion =	comentarConTrait & saludarConComposicion = saludarConTrait .! !

!ComposicionToTrait methodsFor: 'as yet unclassified' stamp: 'Pablo 5/10/2013 22:44'!
traitConverter: unaClase

	|selectors name newTrait|
	
	selectors := unaClase methodDictionary.
	name := unaClase name.
	"Borro Clase"
	Smalltalk removeClassNamed: name.
	
	newTrait := Trait named: name uses: '' category: 'Test-ComposicionToTrait'.
	
	selectors do: [:selector| newTrait compile: selector]. 
	
	
	
	^newTrait. 
	
	
	
	
	
	 
	
	

	 	! !
